#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdlib.h>

#include <gdk/gdkkeysyms.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "io_util.c"
#include "lists_loader.c"
#include "shared.c"
#include "stampa_ricette.c"


void
on_numera_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ 
  show_ricetta();
  freeze(deskbase,"numera_dsk",0);
  freeze(deskbase,"numera",0);
}


void
on_anagrafica_farmacie1_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ ana_farm = create_ana_farm();
  gtk_widget_set_uposition (ana_farm, 50, 55);
  gtk_widget_show(ana_farm);
  focus_to(ana_farm,"nm_far");
  freeze(ana_farm,"far_save",0);
}


void
on_opzioni1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ GtkWidget *eventbox6;
  gchar     *linee   = NULL;
  gchar     *colonne = NULL;

  linee   =  (gchar *)query_uni("SELECT y from mat_xy");
  colonne =  (gchar *)query_uni("SELECT x from mat_xy");
  
  coordinate = create_coordinate();
  eventbox6 = lookup_widget(coordinate,"eventbox6");
  setcolor(255,255,255,eventbox6,"bg_normal");
  gtk_widget_show(coordinate);

  if (linee)
   text_to(coordinate,"linee",linee);
 
  if (colonne)
   text_to(coordinate,"colonne",colonne);

  freeze(deskbase,"ft_button",0);
  freeze(deskbase,"opzioni1",0);
}


void
on_esci1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ out = create_out();
  gtk_widget_show(out);
}


void
on_numera_dsk_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ 
  show_ricetta();
  freeze(deskbase,"numera_dsk",0);
  freeze(deskbase,"numera",0);
}


void
on_farma_button_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ ana_farm = create_ana_farm();
  gtk_widget_set_uposition (ana_farm, 50, 55);
  gtk_widget_show(ana_farm);
  focus_to(ana_farm,"nm_far");
  freeze(ana_farm,"far_save",0);
  freeze(deskbase,"farma_button",0);
  freeze(deskbase,"anagrafica_farmacie1",0);
}


void
on_ft_button_clicked                   (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ GtkWidget *eventbox6;
  gchar     *linee   = NULL;
  gchar     *colonne = NULL;

  linee   =  (gchar *)query_uni("SELECT y from mat_xy");
  colonne =  (gchar *)query_uni("SELECT x from mat_xy");
  
  coordinate = create_coordinate();
  eventbox6 = lookup_widget(coordinate,"eventbox6");
  setcolor(255,255,255,eventbox6,"bg_normal");
  gtk_widget_show(coordinate);

  if (linee)
   text_to(coordinate,"linee",linee);
 
  if (colonne)
   text_to(coordinate,"colonne",colonne);

  freeze(deskbase,"ft_button",0);
  freeze(deskbase,"opzioni1",0);
}


void
on_button_opz_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ GtkWidget *combo3;
  gchar comando[100];
  selezione = create_selezione();
  gtk_widget_show(selezione);
  sprintf(comando,"SELECT nome FROM farmacie ORDER BY nome");

  combo3 = lookup_widget(selezione,"combo3");

  load_combo(comando,combo3,Nome_start);
  freeze(deskbase,"button_opz",0);
}


void
on_uscita_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
 out = create_out();
 gtk_widget_show(out);
}


gboolean
on_ana_farm_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  freeze(deskbase,"farma_button",1);
  freeze(deskbase,"anagrafica_farmacie1",1);
  return FALSE;
}


gboolean
on_nm_far_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { if (event->keyval != GDK_Tab )
             focus_to(ana_farm,"ind_far");
            Nome_Far = g_strdup(txt);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_ind_far_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { if (event->keyval != GDK_Tab )
             focus_to(ana_farm,"citta");
            Indi_Far = g_strdup(txt);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_citta_key_press_event               (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { if (event->keyval != GDK_Tab )
             focus_to(ana_farm,"prov");
            City_Far = g_strdup(txt);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_prov_key_press_event                (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { if (event->keyval != GDK_Tab )
             focus_to(ana_farm,"codice_reg");
            Prov_Far = g_strdup(txt);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}

gboolean
on_codice_reg_key_press_event                 (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

   { if (*txt)
       { if ((isalpha(*txt) != 0)) gdk_beep();
         else
          Codr_Far = strdup(txt);
        }
      else gdk_beep();
   }

  return FALSE;
}


void
on_anafar_close_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  gtk_widget_destroy(ana_farm);
  freeze(deskbase,"farma_button",1);
  freeze(deskbase,"anagrafica_farmacie1",1);
  Nome_Far = NULL;
  Indi_Far = NULL;
  City_Far = NULL;
  Prov_Far = NULL;
  Codr_Far = NULL;
}


void
on_far_save_clicked                    (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ gchar comando[500];

  sprintf(comando,"INSERT INTO farmacie (nome,indirizzo,citta,prov,cod)\
  VALUES ('%s','%s','%s','%s','%s');",Nome_Far,Indi_Far,City_Far,\
  Prov_Far,Codr_Far);
  mysql_real_query(&mysql,comando,strlen(comando));
  text_to(ana_farm,"nm_far","");
  text_to(ana_farm,"ind_far","");
  text_to(ana_farm,"citta","");
  text_to(ana_farm,"prov","");
  text_to(ana_farm,"codice_reg","");
  freeze(ana_farm,"far_save",0);
  Nome_Far = NULL;
  Indi_Far = NULL;
  City_Far = NULL;
  Prov_Far = NULL;
  Codr_Far = NULL;
}


gboolean
on_find_far_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar comando[200];
  gchar     *key;

  key = (gchar * )get_testo(ana_farm,"find_far");

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter )
   { sprintf(comando,"SELECT nome FROM farmacie WHERE nome LIKE '%s%%' ORDER BY nome",key);
     treeview1 = lookup_widget(GTK_WIDGET(ana_farm),"treeview1");
     load_list(treeview1,comando,"mt_reat.png");
   }

  return FALSE;
}


gboolean
on_vr_nome_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { Nome_Cmp = g_strdup(txt);
            if ( strcmp(Nome_Far,Nome_Cmp) != 0)
             freeze(ana_farm,"var_frsave",1);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_vr_indfar_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { Indi_Cmp = g_strdup(txt);
            if ( strcmp(Indi_Far,Indi_Cmp) != 0)
             freeze(ana_farm,"var_frsave",1);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_vr_citta_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { City_Cmp = g_strdup(txt);
            if ( strcmp(City_Far,City_Cmp) != 0)
             freeze(ana_farm,"var_frsave",1);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_vr_prov_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) == 0)) gdk_beep();
         else
          { Prov_Cmp = g_strdup(txt);
            if ( strcmp(Prov_Far,Prov_Cmp) != 0)
             freeze(ana_farm,"var_frsave",1);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_vr_cod_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) != 0)) gdk_beep();
         else
          { Codr_Cmp = g_strdup(txt);
            if ( strcmp(Codr_Far,Codr_Cmp) != 0)
             freeze(ana_farm,"var_frsave",1);
           }
        }
      else gdk_beep();
   }

  return FALSE;
}


void
on_far_vclose_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  gtk_widget_destroy(ana_farm);
  freeze(deskbase,"farma_button",1);
  freeze(deskbase,"anagrafica_farmacie1",1);
}


void
on_var_frsave_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ gchar     comando[300];
  MYSQL_RES *res = NULL;
  gint      n_tuple;

  freeze(ana_farm,"var_frsave",0);

  /* Controllo sul nome */
  if (Nome_Cmp)
   { if ( strcmp(Nome_Far,Nome_Cmp) != 0 )
      { sprintf(comando,"UPDATE farmacie SET nome='%s'\
        WHERE id='%s';", Nome_Cmp,Record);
        mysql_real_query(&mysql,comando,strlen(comando));
        Nome_Cmp = NULL;
       }
   }

  /* Controllo sull'indirizzo */
  if (Indi_Cmp)
   { if ( strcmp(Indi_Far,Indi_Cmp) != 0 )
      { sprintf(comando,"UPDATE farmacie SET indirizzo='%s'\
        WHERE id='%s';", Indi_Cmp,Record);
        mysql_real_query(&mysql,comando,strlen(comando));
        Indi_Cmp = NULL;
       }
   }

  /* Controllo sulla citta */
  if (City_Cmp)
   { if ( strcmp(City_Far,City_Cmp) != 0 )
      { sprintf(comando,"UPDATE farmacie SET citta='%s'\
        WHERE id='%s';", City_Cmp,Record);
        mysql_real_query(&mysql,comando,strlen(comando));
        City_Cmp = NULL;
       }
   }

  /* Controllo sulla provincia */
  if (Prov_Cmp)
   { if ( strcmp(Prov_Far,Prov_Cmp) != 0 )
      { sprintf(comando,"UPDATE farmacie SET prov='%s'\
        WHERE id='%s';", Prov_Cmp,Record);
        mysql_real_query(&mysql,comando,strlen(comando));
        Prov_Cmp = NULL;
       }
   }

   /* Controllo sul Codice Regionale */
  if (Codr_Cmp)
   { if ( strcmp(Codr_Far,Codr_Cmp) != 0 )
      { sprintf(comando,"UPDATE farmacie SET cod='%s'\
        WHERE id='%s';", Codr_Cmp,Record);
        mysql_real_query(&mysql,comando,strlen(comando));
        Codr_Cmp = NULL;
       }
   }

     sprintf(comando,"SELECT nome FROM farmacie ORDER BY nome");
     mysql_real_query(&mysql,comando,strlen(comando));
     res = mysql_store_result(&mysql);
     n_tuple = mysql_num_rows(res);
     if (n_tuple > 0) 
       load_list(treeview1,comando,"mt_reat.png");

}


void
on_reload_far_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ 
  reload_lista();
  text_to(ana_farm,"find_far","");
}


void
on_btt_far_cancel_clicked              (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  farm_cancel = create_farm_cancel();
  gtk_widget_show(farm_cancel);
  gdk_beep();
}


void
on_info_ok_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
}


void
on_fr_nodel_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(farm_cancel);
}


void
on_fr_sidel_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[100];
  gint  i;
  gchar *elementi[] = { "nome","via","citta","prov","cod" };
  gchar *p_widget[] = { "vr_nome","vr_indfar","vr_citta",\
                          "vr_prov","vr_cod" };
  treeview1   = lookup_widget(GTK_WIDGET(ana_farm),"treeview1");
  sprintf(comando,"DELETE FROM farmacie  WHERE id='%s'",Record);
  mysql_real_query(&mysql,comando,strlen(comando));
  reload_lista();
  gtk_widget_destroy(farm_cancel);
  sprintf(comando,"DELETE FROM last_farma WHERE id='%s'",Record);
  mysql_real_query(&mysql,comando,strlen(comando));
  sprintf(comando,"SELECT nome FROM farmacie ORDER BY nome");

  for ( i = 0; i < 5; i++)
   { p_widget[i] = (gchar *)lookup_widget(ana_farm, p_widget[i]);
     gtk_entry_set_text (GTK_ENTRY (p_widget[i]),"");
   }
  load_list(treeview1,comando,"mt_reat.png");
}


void
on_okbtt_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{ mysql_close(&mysql);
  gtk_exit(1);
}


void
on_info_btt_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
}


void
on_button_close_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(Go_start);
  freeze(deskbase,"numera_dsk",1);
  freeze(deskbase,"numera",1);
}


gboolean
on_entry_data_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{  gchar *data;
   data = (gchar * )get_testo(Go_start, "entry_data");
   entry_data = lookup_widget(Go_start,"entry_data");

   if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
     { if (*data)
         {  if (check_date(data, entry_data))
             focus_to(Go_start,"da_numero");
           else gdk_beep();
         }
        else gdk_beep();
     } 

  return FALSE;
}


void
on_def_coord_btt_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ /* Valori di default per le coordinate di stampa */
  text_to(coordinate,"linee","20");
  text_to(coordinate,"colonne","52");
}


void
on_ok_coord_btt_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *linee      = NULL;
  gchar *colonne    = NULL;
  gchar *db_linee   = NULL;
  gchar *db_colonne = NULL;
  gchar comando[200];

  linee      = (gchar * )get_testo(coordinate,"linee");
  colonne    = (gchar * )get_testo(coordinate,"colonne");
  db_linee   = (gchar *)query_uni("SELECT x from mat_xy");
  db_colonne = (gchar *)query_uni("SELECT y from mat_xy");

  /* Se ho il dato lo aggiorno */
  if (db_linee)
   { if (linee)
     sprintf(comando,"UPDATE mat_xy SET y='%s'",linee);
   } /* altrimenti inserisco */
  else if (linee)
       sprintf(comando,"INSERT INTO mat_xy (y) VALUES ('%s');",linee);

  mysql_real_query(&mysql,comando,strlen(comando));

  db_colonne = (gchar *)query_uni("SELECT y from mat_xy");
  if (db_colonne)
   { if (colonne)
     sprintf(comando,"UPDATE mat_xy SET x='%s'",colonne);
   } 
  else if (colonne)
       sprintf(comando,"INSERT INTO mat_xy (x) VALUES ('%s');",colonne);

  mysql_real_query(&mysql,comando,strlen(comando));
  gtk_widget_destroy(coordinate);
  freeze(deskbase,"ft_button",1);
  freeze(deskbase,"opzioni1",1);
}


gboolean
on_Coordinate_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_deskbase_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  out = create_out();
  gtk_widget_show(out);

  return TRUE;
}


void
on_sele_btt_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(selezione);
  freeze(deskbase,"button_opz",1);
}


void
on_data_sistema_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{ gchar *giorno = NULL;
  gchar *mese   = NULL;
  gchar *anno   = NULL;
  gchar buf[2];
  gchar anno_cut[2];
  gchar data[10];

  giorno = (gchar *) query_uni("SELECT EXTRACT(day FROM current_date);");
  mese   = (gchar *) query_uni("SELECT EXTRACT(month FROM current_date);");
  anno   = (gchar *) query_uni("SELECT EXTRACT(year FROM current_date);");
  query_uni("SELECT NULL;"); 

  sprintf(buf,"%s",anno);
  sprintf(anno_cut,"%c%c",buf[2],buf[3]);
  sprintf(data,"%s/%s/%s",giorno,mese,anno_cut);

  text_to(Go_start,"entry_data",data);
  text_to(Go_start,"entry4",giorno);
  text_to(Go_start,"entry5",mese);
  text_to(Go_start,"entry6",anno_cut);

  focus_to(Go_start,"da_numero");
}


gboolean
on_da_numero_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));
  Numero_Start = atoi(txt);

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
       { if ((isalpha(*txt) != 0)) gdk_beep();
         else
           focus_to(Go_start,"a_numero");
        }
      else gdk_beep();
   }

  return FALSE;
}


gboolean
on_a_numero_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *txt;
  txt = (gchar *)gtk_entry_get_text (GTK_ENTRY (widget));
  Numero_End = atoi(txt);

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter\
      || event->keyval == GDK_Tab )
   { if (*txt)
      { if ((isalpha(*txt) != 0)) gdk_beep(); }
     else gdk_beep();
    }

  return FALSE;
}

gboolean
on_ana_farm_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ 
  if (Nome_Far && Indi_Far && City_Far && Prov_Far && Codr_Far)
     freeze(ana_farm,"far_save",1);

  return FALSE;
}


void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{ GtkWidget *notebook1;
  MYSQL_RES *res = NULL;
  gchar     comando[200];
  gint      note_number, n_tuple;

  notebook1   = lookup_widget(ana_farm,"notebook1");
  note_number = gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook1));
  treeview1   = lookup_widget(GTK_WIDGET(ana_farm),"treeview1");
  freeze(ana_farm,"var_frsave",0);

  if ( note_number == 0 )
   { sprintf(comando,"SELECT nome FROM farmacie ORDER BY nome");
     mysql_real_query(&mysql,comando,strlen(comando));
     res = mysql_store_result(&mysql);
     n_tuple = mysql_num_rows(res);
     if (n_tuple > 0) 
       load_list(treeview1,comando,"mt_reat.png");
   }
}


void
on_treeview1_cursor_changed            (GtkTreeView     *treeview,
                                        gpointer         user_data)
{ GtkTreeSelection *selection = NULL;
  GtkTreeIter iter;
  GtkTreeModel *model = NULL;
  GList  *sel_row_list = NULL;
  gchar *num = NULL;
  gchar comando[300];

  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
  treeview1 = lookup_widget(GTK_WIDGET(ana_farm),"treeview1");

  if (gtk_tree_selection_get_selected(selection, &model, &iter))
    { sel_row_list = gtk_tree_selection_get_selected_rows(selection, &model);
      num = gtk_tree_path_to_string((GtkTreePath*) sel_row_list->data);
      print_elementi("SELECT * from farmacie ORDER BY nome",atoi(num));
      g_free(num);
    }

}

void
on_chiudi_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(coordinate);
  freeze(deskbase,"ft_button",1);
  freeze(deskbase,"opzioni1",1);
}


void
on_combo2_changed                      (GtkComboBox     *combobox,
                                        gpointer         user_data)
{ gchar *nome;
  gchar *id;
  gchar comando[100];
  gchar timbro[200];
  nome = (gchar *) gtk_entry_get_text (GTK_ENTRY (GTK_BIN (combobox)->child));
  sprintf(comando,"SELECT id FROM farmacie WHERE nome='%s'",nome);
  id   = (gchar *) query_uni(comando);
  query_uni("SELECT NULL;");
  sprintf(comando,"UPDATE last_farma SET id='%s'",id);
  mysql_real_query(&mysql,comando,strlen(comando));
  set_farmacia();

  sprintf(timbro,\
  "    -- Farmacia  --\n\
Dott. %s\n%s\n%s (%s) -- COD. %s",\
Nome_start,Indi_start,City_start,Prov_start,Codr_start);

  set_label(Go_start,"label_timbro",timbro);
  freeze(deskbase,"ft_button",1);
  freeze(deskbase,"opzioni1",1);
}


void
on_combo3_changed                      (GtkComboBox     *combobox,
                                        gpointer         user_data)
{ gchar *nome;
  gchar *id;
  gchar comando[100];
  nome = (gchar *) gtk_entry_get_text (GTK_ENTRY (GTK_BIN (combobox)->child));
  sprintf(comando,"SELECT id FROM farmacie WHERE nome='%s'",nome);
  id   = (gchar *) query_uni(comando);
  query_uni("SELECT NULL;");
  sprintf(comando,"UPDATE last_farma SET id='%s'",id);
  mysql_real_query(&mysql,comando,strlen(comando));
  set_farmacia();
}


void
on_out_no_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{ 
  gtk_widget_destroy(out);
}


void
on_out_yes_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ 
 mysql_close(&mysql);
 gtk_exit(1);

}


void
on_stampa_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{ GtkWidget *comboboxentry1;
  start_print = create_start_print();
  gtk_widget_show(start_print);
  comboboxentry1 = lookup_widget(start_print,"comboboxentry1");
  gtk_combo_box_set_active (GTK_COMBO_BOX (comboboxentry1), 0);
}


void
on_button_print_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{ GtkWidget *comboboxentry1;
  gchar *dev;
  comboboxentry1 = lookup_widget(start_print,"comboboxentry1");
  dev = (gchar *) gtk_entry_get_text (GTK_ENTRY (GTK_BIN (comboboxentry1)->child));
  stampa_timbro(dev);
  /* Autorizzo la stampa */
  Blocca_Stampa = 0;
  gtk_widget_destroy(start_print);
}


void
on_annulla_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(start_print);
}


void
on_Blocca_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{ gchar buf[100];
  sprintf(buf,"kill -9 %ld",Pid);
  //system(buf);
  Blocca_Stampa = 1;
}


void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  checkbutton1 = lookup_widget(Go_start,"checkbutton1");
  if ( GTK_TOGGLE_BUTTON (checkbutton1)->active) 
   Solo_Numero = 1;
  else Solo_Numero = 0;
}


gboolean
on_Go_start_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  freeze(deskbase,"numera_dsk",1);
  freeze(deskbase,"numera",1);

  return FALSE;
}


gboolean
on_coordinate_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  freeze(deskbase,"ft_button",1);
  freeze(deskbase,"opzioni1",1);

  return FALSE;
}


gboolean
on_selezione_delete_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  freeze(deskbase,"button_opz",1);
  return FALSE;
}


void
on_info2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ GtkWidget *eventbox7;
  GtkWidget *about;

  about = create_about();
  eventbox7 = lookup_widget(about,"eventbox7");
  setcolor(255,255,255,eventbox7,"bg_normal");
  gtk_widget_show(about);
}


void
on_radio___toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
 Incremento = 0;
}


void
on_radio_incre_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
 Incremento = 1;
}

void
on_button_up_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *linee   = NULL;
  gchar buf[30];

  linee = (gchar * )get_testo(coordinate,"linee");

  sprintf(buf,"%d",atoi(linee) - 1);
  text_to(coordinate,"linee",buf);
}


void
on_button_sx_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *colonne   = NULL;
  gchar buf[30];

  colonne = (gchar * )get_testo(coordinate,"colonne");

  sprintf(buf,"%d",atoi(colonne) - 1);
  text_to(coordinate,"colonne",buf);
}


void
on_button_dx_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *colonne   = NULL;
  gchar buf[30];

  colonne = (gchar * )get_testo(coordinate,"colonne");

  sprintf(buf,"%d",atoi(colonne) + 1);
  text_to(coordinate,"colonne",buf);
}


void
on_button_dn_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *linee   = NULL;
  gchar buf[30];

  linee = (gchar * )get_testo(coordinate,"linee");

  sprintf(buf,"%d",atoi(linee) + 1);
  text_to(coordinate,"linee",buf);
}

