#include "io_util.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "lists_loader.h"

/* Ghiaccia e scongela un widget */
void freeze(GtkWidget *container,const gchar *obj,gint stat)
     { GtkWidget *widget;
       widget = lookup_widget(container,obj);
       gtk_widget_set_sensitive(GTK_WIDGET(widget), stat);
      }

/* Segnala un errore */
void mex(const gchar *testo)
    { info = create_info();
      info_label = lookup_widget(GTK_WIDGET(info),"info_label");
      gdk_beep();
      gtk_label_set(GTK_LABEL(info_label), testo);
      gtk_widget_show(info);
    }

/* Cattura il testo da una entry */
const gchar *get_testo(GtkWidget *finestra, const char *w_figlio)
  {  GtkWidget *entry;
     const gchar  *stringa;

     entry =  lookup_widget(finestra,w_figlio);
     stringa = gtk_entry_get_text(GTK_ENTRY(entry));

     return (stringa);
  }

/* Sposta il focus sul widget desiderato */
 void focus_to(GtkWidget *container, const gchar *obj)
     { GtkWidget *widget;
       widget = lookup_widget(GTK_WIDGET(container),obj);
       gtk_window_set_focus(GTK_WINDOW(container),widget);
     }

/* Scrive il testo sulla entry desiderata */
 void text_to(GtkWidget *container, const gchar *obj, const gchar *str)
     { GtkWidget *entry;
       entry = lookup_widget(GTK_WIDGET(container),obj);
       gtk_entry_set_text (GTK_ENTRY (entry), str);
     }

/* Testo sulla label */
void set_label(GtkWidget *finestra, const char *w_figlio,const gchar *testo)
  {  GtkWidget *label = NULL;
     label = lookup_widget(GTK_WIDGET(finestra),w_figlio);
     gtk_label_set(GTK_LABEL(label), testo);
  }

/* Caricatore di ComboBox */
void load_combo(char *comando, GtkWidget *combo,gchar *nome)
{
  int i, n_tuple;
  MYSQL_RES *res;
  MYSQL_ROW  row;
  char *elemento = NULL;

  mysql_real_query(&mysql,comando,strlen(comando));
  res = mysql_store_result(&mysql);
  n_tuple = mysql_num_rows(res);

  for (i = 0; i < n_tuple; i++) 
   { row = mysql_fetch_row(res);
     elemento = g_strdup(row[0]);
     gtk_combo_box_append_text (GTK_COMBO_BOX (combo), elemento);
     if (nome)
      { if (strcmp(elemento,nome) == 0)
         gtk_combo_box_set_active (GTK_COMBO_BOX (combo), i);
      }
     
    }
}

/* Funzione di controllo della data
 * (C) Paolo Bongiorno
 * Tutti i diritti riservati */
int check_date(gchar data_char[60], GtkWidget *entry)
  { gchar comando[200];
    gchar giorno[10];
    gchar mese[10];
    gchar anno[10];
    gchar anno_sys[10];
    gint  anno_now, anno_int;
    gchar anno_test[10];
    gchar *date_val;
    MYSQL_RES *res;
    MYSQL_ROW row;
    gchar str[10];
    gint giorno_test;
    gint i, bisestile = 0, limite = 31;

    sprintf(giorno,"%c%c", data_char[0],data_char[1]);
    sprintf(mese,"%c%c", data_char[2],data_char[3]);
    sprintf(anno,"%c%c", data_char[4],data_char[5]);

    if (strcmp(mese,"04") == 0)  limite = 30;
    if (strcmp(mese,"06") == 0)  limite = 30;
    if (strcmp(mese,"09") == 0)  limite = 30;
    if (strcmp(mese,"11") == 0)  limite = 30;

    sprintf(comando, "SELECT EXTRACT(year FROM current_date);" );
    mysql_real_query(&mysql,comando,200);
    res = mysql_store_result(&mysql);
    row = mysql_fetch_row(res);
    sprintf(anno_sys,row[0]);
    anno_now    = atoi(anno_sys);
    anno_int    = atoi(anno_test);
    giorno_test = atoi(giorno);

    sprintf(anno_test,"%c%c%s",anno_sys[0],anno_sys[1],anno);

    if (strcmp(anno_test,anno_sys) != 0 )
      { gdk_beep();
        return 0;
      }
    else { for ( i = 2000; i < anno_now; i += 4)
            { if ( anno_now == anno_int)
               { if (strcmp(mese,"02")  == 0)
                  limite = 29; 
                }
              else if (strcmp(mese,"02")  == 0 )
                      limite = 28;
            }  

            if ( giorno_test > 0 && giorno_test <= limite )
             { sprintf(data_char, "%s/%s/%s",giorno,mese,anno);
               strcpy(str,data_char);
               gtk_entry_set_text (GTK_ENTRY (entry), "");
               gtk_entry_set_text (GTK_ENTRY (entry), str);
               text_to(Go_start,"entry4",giorno);
               text_to(Go_start,"entry5",mese);
               text_to(Go_start,"entry6",anno);
               return 1;
             }
            else return 0;
          }
}

 /* Restituisce il risultato di una query a 1 riga */
const gchar *query_uni(const gchar *comando)
     { MYSQL_RES *res = NULL;
       MYSQL_ROW row  = NULL;
       gint n_tuple   = 0;
       static gchar *return_query = NULL;
       if ( ! mysql_real_query(&mysql,comando,strlen(comando)))
         { res = mysql_store_result(&mysql);
           n_tuple = mysql_num_rows(res);
           if ( n_tuple > 0 )
             { row = mysql_fetch_row(res);
               return_query = g_strdup(row[0]);
             }
         }
        mysql_free_result (res);
        return (return_query);
      }

/* Elementi della lista */
void print_elementi(gchar *comando, gint Selezione)
  { MYSQL_ROW row;
    MYSQL_RES *res   = NULL;
    unsigned int i, n_tuple;

    gchar *elementi[] = { "nome","via","citta","prov","cod" };
    gchar *p_widget[] = { "vr_nome","vr_indfar","vr_citta",\
                          "vr_prov","vr_cod" };

    if ( ! mysql_real_query(&mysql,comando,strlen(comando)))
     { res = mysql_store_result(&mysql);
       n_tuple = mysql_num_rows(res);

       for ( i = 0; i < n_tuple; i++)
        {  mysql_field_seek (res, 0); // sposta a inizio riga
           row = mysql_fetch_row(res);

           if ( i == Selezione ) // Se la riga corrisponde alla sel. leggo
            { for ( i = 0; i < 5; i++)
              {  Record      = g_strdup(row[0]);
                 elementi[i] = g_strdup(row[i+1]);
                 p_widget[i] = (gchar *)lookup_widget(ana_farm, p_widget[i]);
                 gtk_entry_set_text (GTK_ENTRY (p_widget[i]), elementi[i]);
               }
             Nome_Far = g_strdup(row[0]);
             Indi_Far = g_strdup(row[1]);
             City_Far = g_strdup(row[2]);
             Prov_Far = g_strdup(row[3]);
             Codr_Far = g_strdup(row[4]);
             }
         }
      }
     mysql_free_result (res);
  } 

/* Reload della lista farmacie */
void reload_lista(void)
{ MYSQL_RES *res = NULL;
  gchar     comando[100];
  gint      n_tuple;

  sprintf(comando,"SELECT nome FROM farmacie ORDER BY nome");
  mysql_real_query(&mysql,comando,strlen(comando));
  res = mysql_store_result(&mysql);
  n_tuple = mysql_num_rows(res);
  if (n_tuple > 0)
   load_list(treeview1,comando,"mt_reat.png");
}

void check_farma(void)
  { gchar comando[500];
    gchar *id = NULL;

    id = (gchar *) query_uni("SELECT id FROM last_farma");
    if (!id)
     { id = (gchar *) query_uni("SELECT id FROM farmacie ORDER BY nome");
       if (id)
       { sprintf(comando,"INSERT INTO last_farma (id) VALUES ('%s');",id);
         mysql_real_query(&mysql,comando,strlen(comando));
       }
     }
  }

gchar *get_nome(void)
{ gchar comando[200];
  gchar *id;
  gchar *nome;
  id =  (gchar *) query_uni("SELECT id FROM last_farma);");
  if (id)
   { sprintf(comando,"SELECT nome FROM farmacie WHERE id='%s'",id);
     nome      = (gchar *) query_uni(comando);
     id        = (gchar *) query_uni("SELECT NULL;");
   }
  else  nome      = g_strdup("---");

  return (nome);
 }

void set_farmacia(void)
 { gchar *id        = NULL;
   gchar  comando[200];

  check_farma();

  id =  (gchar *) query_uni("SELECT id FROM last_farma);");
  if (id)
   { Nome_start   = get_nome();

     sprintf(comando,"SELECT indirizzo FROM farmacie WHERE id='%s'",id);
     Indi_start = (gchar *) query_uni(comando);

     sprintf(comando,"SELECT citta FROM farmacie WHERE id='%s'",id);
     City_start = (gchar *) query_uni(comando);

     sprintf(comando,"SELECT prov FROM farmacie WHERE id='%s'",id);
     Prov_start = (gchar *) query_uni(comando);

     sprintf(comando,"SELECT cod FROM farmacie WHERE id='%s'",id);
     Codr_start = (gchar *) query_uni(comando);

     id        = (gchar *) query_uni("SELECT NULL;");
   }
  else { Nome_start = g_strdup("---");
         Indi_start = g_strdup("---");
         City_start = g_strdup("---");
         Prov_start = g_strdup("---");
         Codr_start = g_strdup("000");
       }
 }

gchar *set_numero(void)
 {  gchar *num   = NULL;
    gchar  comando[200];

    num =  (gchar *) query_uni("SELECT num FROM last_num");

    if (!num)
     { sprintf(comando,"INSERT INTO last_num (id) VALUES ('1');");
       mysql_real_query(&mysql,comando,strlen(comando));
       num = g_strdup("1");
     }

   return (num);
  }
