#include <gtk/gtk.h>
#include "lists_loader.h"

GdkPixbuf*
create_new_pixbuf(gchar *filename)
{
  GdkPixbuf *pix = NULL;

  g_return_val_if_fail(filename != NULL, NULL);

  pix = gdk_pixbuf_new_from_file(filename, NULL);
  if (!pix)
    g_print("Impossibile leggere il file di immagine %s\n", filename);
  
  return  pix;
} 
/* Se l' icona passata a list_loader e' nulla questa funzione restituisce il default */
const gchar *get_icon(void)
 { static gchar icon[60] ;
 
   /* Icona di default */
   sprintf(icon,"mt_reat.png");

   return icon;
 }

void load_list(GtkWidget *vista,char *comando,const gchar *pix)
{ 
  gint i, n_tuple = 0, n_campi;
  gchar *elemento;
  MYSQL_RES *res;
  MYSQL_ROW row;
  gchar icona[60];

  enum {
  COLONNA_PIX,
  COLONNA_STRINGHE,
  COLONNE
  };

  GtkTreeViewColumn *viewcolumn;
  GtkTreePath *path;
  GtkTreeModel *model;
  GtkTreeIter iter;
  GdkPixbuf *image;
  gchar pixmap_file[200];

  /* Adesso voglio visualizzare il modello */
  model = gtk_tree_view_get_model(GTK_TREE_VIEW(vista));

  mysql_real_query(&mysql,comando,strlen(comando));
  res = mysql_store_result(&mysql);
  n_tuple = mysql_num_rows(res);
  n_campi = mysql_num_fields(res);

  /* Puliamo il precedente loading */
  gtk_list_store_clear(GTK_LIST_STORE(model));

  if (n_tuple > 0 ) 
    { for (i = 0; i < n_tuple; i++) 
        { row = mysql_fetch_row(res);
          elemento = g_strdup(row[0]);
          if (*pix)
             sprintf(icona,"%s",pix);
          else  sprintf(icona,"%s",get_icon());
          sprintf(pixmap_file,"%s%s",Icon_path,icona);
          image = create_new_pixbuf(pixmap_file);
          gtk_list_store_append(GTK_LIST_STORE(model), &iter);
          gtk_list_store_set(GTK_LIST_STORE(model), &iter, 
          COLONNA_PIX,image, 
          COLONNA_STRINGHE, elemento, 
          -1);
        } 
     /* Sposta il focus sulla seconda colonna "1" della prima riga "0" */
     path = gtk_tree_path_new_from_indices(0, -1);
     viewcolumn = gtk_tree_view_get_column(GTK_TREE_VIEW(vista), 1);
     gtk_tree_view_set_cursor(GTK_TREE_VIEW(vista), path, viewcolumn, TRUE);
     }
}
